; install.scm
; $Id: update.scm,v 1.5 2005/10/12 13:24:15 lioka Exp $

(use-translation _ "alterator-packages")


caption (_ "Updating Indices...")
margin 1 spacing 1

(define *packages-progress-error* '())

(define (packages-update-progress sender dest iface member args)
  (if (and (string=? iface "org.altlinux")
	   (string=? member "alterator"))
      (let ((command (car args))
            (arg (cadr args))
            (rest (or (and (pair? (cddr args)) (caddr args)) "")))
        (cond
	 ;; begin
         ((and (string=? command "progress")
               (string=? arg "begin"))
	  '(/ctrl/look action "ignore"))
	 ;; start update
         ((and (string=? command "progress")
               (string=? arg "update"))
          (packages-update-bar-id total (string->number rest))
          (packages-update-bar-id value 0)
          (packages-update-text-id text ""))
	 ;; update progress bar
         ((string=? command "step")
          (let ((val (+ 1 (packages-update-bar-id value))))
            (packages-update-text-id text-append arg)
            (packages-update-bar-id value val)))
	 ;; accumulate errors
	 ((string=? command "error")
	  (set! *packages-progress-error*
		(cons (cons arg rest)
		      *packages-progress-error*)))
	 ;; normal termination
         ((and (string=? command "progress")
               (string=? arg "end"))
	  (end-dialog (or (null? *packages-progress-error*)
			  *packages-progress-error*)))
	 ;; abort
	 ((and (string=? command "progress")
               (string=? arg "abort"))
	  (end-dialog #f))
	 ;; uncatched
         (else
          (packages-update-text-id text-append (string-append "XXX" command ":" arg "\n")))))
      ;; FIXME not ours dbus message, fake it
      '(/ctrl/look action "ignore")))

(define (packages-update)
  (woo-write "/packages/control" 'control "quit")
  (woo-write "/packages/control" 'control "update")
  (vbox
   sizepolicy 'expanding
   (relative-width 65)
   (id 'packages-update-label-id
       (label (_ "Updating Indices...")))
   (id 'packages-update-text-id
       (textbox "" readonly #t))
   (id 'packages-update-bar-id
       (progressbar total 1 value 0))))

(on-dbus
 (packages-update-progress sender destination interface dmember args))

(packages-update)
